module PropertyAttributes
	def self.attrs_to_sym_hash
		{
			"ID" => :id,
			"CIK Number" => :cik_number,
			"Property Name" => :property_name,
			"Address" => :address,
			"City" => :city,
			"State" => :state,
			"Zip Code" => :zip_code,
			"County" => :county,
			"General Property Type" => :general_property_type,
			"Specific Property Type" => :specific_property_type,
			"Year Built" => :year_built,
			"Year Renovated" => :year_renovated,
			"Loan Amount" => :loan_amount,
			"Interest Rate" => :interest_rate,
			"PPP" => :ppp,
			"Loan Date" => :loan_date,
			"Maturity Date" => :maturity_date,
			"Originator" => :orginator,
			"Appraised Value" => :appraised_value,
			"Appraisal Date" => :appraisal_date,
			"LTV" => :ltv,
			"DSCR" => :dscr,
			"NOI" => :noi,
			"NCF" => :ncf,
			"Square Feet" => :square_feet,
			"Title / Collateral" => :title_collateral,
			"Ground Lease Expiration" => :ground_lease_expiration,
			"Number of Units" => :number_of_units,
			"Unit of Measure" => :unit_of_measure,
			"Amortization" => :amortization,
			"Loan Term" => :loan_term,
			"Accrual Type" => :accrual_type,
			"I/O" => :io,
			"I/O Period" => :io_period,
			"Annual Debt Service" => :annual_debt_service,
			"Occupancy %" => :occupancy,
			"U/W Revenue (EGI)" => :uw_revenue,
			"U/W Expenses" => :uw_expenses
		}
	end

	def create_property_attributes
		PropertyAttributes.attrs_to_sym_hash.each do |key, value|
			attr_accessor value
		end
	end
end
