require "csv"
require File.expand_path("../property.rb", __FILE__)

class PropertyDataLoader
	
	def initialize(manner = :csv)
		@manner = manner
		@properties = []
		@csv_data = nil
	end

	def self.run_and_return_properties
		pdl = PropertyDataLoader.new
		pdl.run_and_return_properties
	end

	def run
		if @manner && @manner == :csv
			load_csv if data.nil?
			csv_to_properties
		end
	end

	def run_and_return_properties
		run
		property_array
	end

	def properties
		@properties
	end

	def property_array
		result = []
		properties.each do |property|
			result << property
		end
		result
	end

	def add_property(property)
		if property.class == Property
			@properties << property
		else
			raise "Unable to Add Property because it is not of the Property Class"
		end
	end

	def data
		@csv_data
	end

	def property_data_path
		# File.expand_path("../training_data/large_property_data.csv", __FILE__)		
		File.expand_path("../training_data/total_data_set.csv", __FILE__)
	end

	def load_csv
		@csv_data = CSV.read(property_data_path, {headers: true})
	end

	def csv_to_properties
		data.each do |row|
			property = Property.new(row)
			add_property(property)
		end
	end
end

# l = PropertyDataLoader.new
# l.run
# p l.properties
# p l.properties.first

